---
layout: post
read_time: true
show_date: true
title:  What is Inter-Bank Offered Rate 
date:   2020-01-16 08:00:00 +0100
description: What is Inter-Bank Offered Rate 
img: posts/2020-01-16-IBOR/ICE_LIBOR_Panel_banks.png 
tags: [Finance, IBOR]
author: SUN Jiangong
canonical_url: 'https://www.sunjiangong.com/what-is-inter-bank-offered-rate-bor.html'
---

IBOR means: Inter-Bank Offered Rate.

The most important IBORs are : <b>Libor</b>, <b>Euribor</b>, and <b>Hibor</b>

##### 1. ICE LIBOR #####

LIBOR: London Inter-Bank Offered Rate

LIBOR is a widely-used benchmark for short-term interest rates.

> LIBOR is currently calculated for five currencies (USD, GBP, EUR, CHF and JPY) and for seven tenors in respect of each currency (Overnight/Spot Next, One Week, One Month, Two Months, Three Months, Six Months and 12 Months). This results in the publication of 35 individual rates (one for each currency and tenor combination) every applicable London business day.

<!--more-->
<br />

<b>Libor Panel Banks:</b>
![](./../../../assets/img/posts/2020-01-16-IBOR/ICE_LIBOR_Panel_banks.png)


<b>Evolution:</b>

LIBOR was supervised by UK <b>FCA (Financial Conduct Authority)</b> before 2012, and then the supervision was shifted to <b>IBA (Intercontinental Exchange Benchmark Administration)</b>.
LIBOR will be replaced by <b>ARR (Alternate Reference Rates)</b> by the end of 2021.

<br/>

##### 2. EURIBOR #####

EURIBOR: Euro Inter-Bank Offered Rate

EURIBOR is published daily on every TARGET day, at or shortly after 11 a.m. CET for each of its Defined Tenors: 1 week, 1 month, 3 months, 6 months, and 12 months, by <b>EMMI (European Money Market Institute)</b>

<br />

<b>EURIBOR Panel Banks:</b>
![](./../../../assets/img/posts/2020-01-16-IBOR/EURIBOR_Panel_banks.PNG)


<b>Evolution:</b>

EURIBOR is published for the first time, along with the introduction of the euro (on 1st January 1999).

Belgian <b>FSMA (Financial Services and Markets Authority)</b> has authorized EMMI as the EURIBOR administrator since 2019.

<br/>

##### 3. HIBOR #####

HIBOR: HongKong Inter-Bank Offered Rate


<b>HIBOR Panel Banks:</b>
![](./../../../assets/img/posts/2020-01-16-IBOR/HIBOR_panel_banks.PNG)


<br/>

##### IBORs size #####

| IBOR | Size  |
| --- | ---  |
| LIBOR | > 350 Trillon $  |
| EURIBOR | > 150 Trillon $  |
| HIBOR | > 2 Trillon $  |


<br/>

References:

https://www.theice.com/iba/libor

https://www.emmi-benchmarks.eu/euribor-org/about-euribor.html

https://www.hkab.org.hk/index.jsp
