---
layout: post
read_time: true
show_date: true
title:  Which tools you need to develop web applications in ReactJS?
date:   2021-12-29 08:00:00 +0100
description: Which tools you need to develop web applications in ReactJS?
img: posts/uncategorized/reactjs.png
tags: [ReactJS]
author: SUN Jiangong
canonical_url: 'https://www.sunjiangong.com/which-tools-you-need-to-develop-web-applications-in-reactjs.html'
---

### Tools:
- Visual studio code
- Chrome

<br/>

### Visual studio code extensions:

- Auto Import

This extension will propose to import the related type you add in your file.
It works for scripts developed in TypeScript and TSX.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/auto-import.png)

<br/>

<!--more-->

- Auto Import - ES6, TX, JSX, TSX 

This extension not only works for scripts developed in TypesScript, TSX, but also for scripts developed in **JSX**.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/auto-import-jsx.png)

<br/>

- Bracket Pair Colorizer

This extension will colorise your code and make it more readable.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/bracket-color.png)

<br/>

- ESLint

ESLint is a tool for identifying and reporting on patterns found in ECMAScript/JavaScript code, with the goal of making code more consistent and avoiding bugs.

ESLint supports **Javascript** code and **TypeScript** code, whereas TSLint only supports TypeScript code.

ESLint uses Espree for JavaScript parsing.
ESLint uses an AST to evaluate patterns in code.
ESLint is completely pluggable, every single rule is a plugin and you can add more at runtime.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/eslint.png)

You can check the [rules](https://eslint.org/docs/rules/){:target="_blank"} proposed by ESLint.

<br/>

- Reactjs code snippets

ReactJs code snippets will facilitate your development by providing a lot of shortcuts to create sample codes.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/reactjs-code-snippets.png)

An example:

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/reactjs-snippets-rcc.gif)

Some snippets:

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/reactjs-code-common-snippets.png)

You can find the full snippets list: [here](https://marketplace.visualstudio.com/items?itemName=xabikos.ReactSnippets){:target="_blank"}.

<br/>

### Chrome extensions:

- React Developer Tools

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/react-dev-tools.png)

With React Dev Tools you can visualize components and profile your application.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/react-dev-tools-components.png)

- Redux DevTools

You can check the redux workflow in React applications developed with Redux.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/redux-devtools.png)

And you can verify the state changes in each step of the redux workflow.

![](./../../../assets/img/posts/2021-12-29-reactjs-starter/redux-devtools-workflow.png)

